import{s as fl,f as m,n as hl,o as gl}from"../chunks/scheduler.63274e7e.js";import{S as cl,i as vl,g as a,s as n,r as p,A as dl,h as r,f as i,c as s,j as pl,u as f,x as o,k as u,y as wl,a as l,v as h,d as g,t as c,w as v}from"../chunks/index.bf3f3f8e.js";import{H as d,E as yl}from"../chunks/EditOnGithub.7d836abf.js";function bl(ni){let w,qt,At,zt,_,Rt,x,Bt,M,si='You can find the 👉 <a href="https://huggingface.co/datasets/huggingface-ml-4-games-course/unity-demos/resolve/main/unit1/Jammo%20the%20Robot%20Sentis%20(v2).zip?download=true" rel="nofollow">complete Unity project here</a>',Et,$,Jt,L,ai='The Sentis Documentation 👉 <a href="https://docs.unity3d.com/Packages/com.unity.sentis@latest" rel="nofollow">https://docs.unity3d.com/Packages/com.unity.sentis@latest</a>',Wt,C,ri='<li><p>Open the Jammo project</p></li> <li><p>Click <a href="https://tinyurl.com/4eun48fb" rel="nofollow">Sentis Pre-Release package</a> or go to Window &gt; Package Manager, click the + icon, select “Add package by name…” and type “com.unity.sentis”</p></li>',Ft,H,oi,Nt,S,ui="<strong>Set the version to 1.3.0</strong>",Yt,y,mi="<li>Press the Add button to install the package.</li>",Dt,P,pi,Vt,k,Kt,I,fi='<a href="https://github.com/huggingface/sharp-transformers" rel="nofollow">Sharp Transformers</a> is a Unity plugin of utilities to <strong>run Transformer 🤗 models in Unity games</strong>.',Qt,j,hi="We need to do it for the tokenization step.",Xt,G,gi="Go to “Window” > “Package Manager” to open the Package Manager.",Zt,U,ci="Click the ”+” in the upper left-hand corner and select “Add package from git URL”.",te,A,vi='Enter the URL of this repository and click “Add”: <a href="https://github.com/huggingface/sharp-transformers.git" rel="nofollow">https://github.com/huggingface/sharp-transformers.git</a>',ee,O,ie,q,di='As described in <a href="https://docs.unity3d.com/Packages/com.unity.sentis@latest" rel="nofollow">Sentis documentation</a>, to use Sentis to run a neural network in Unity, we need to follow these steps.',le,z,wi="<li><p>Use the Unity.Sentis namespace.</p></li> <li><p><strong>Load a neural network</strong> model file.</p></li> <li><p><strong>Create input</strong> for the model.</p></li> <li><p><strong>Create an inference engine</strong> (a worker).</p></li> <li><p><strong>Run the model</strong> with the input to infer a result.</p></li> <li><p><strong>Get the result</strong>.</p></li>",ne,R,yi="In our case, we do all of this in <strong>SentenceSimilarity.cs</strong> file, that will be attached to our robot.",se,B,bi="In awake, we:",ae,E,Ti="<li><p><strong>Load our neural network.</strong></p></li> <li><p>Create an <strong>inference engine</strong> (a worker).</p></li> <li><p><strong>Create an operator</strong>, that will allow us to perform operations with tensors.</p></li>",re,J,_i,oe,W,xi="We have three functions:",ue,F,Mi="<li><em>Encode</em>: takes our player input (text), <strong>tokenizes it, and embeds it</strong>.</li>",me,N,$i,pe,b,Li="<li><em>SentenceSimilarityScores</em>: <strong>calculate the similarity scores</strong> between the input embed (what the user typed) and the comparison embeds (the robot action list)</li>",fe,Y,Ci,he,T,Hi="<li><em>RankSimilarityScores</em>: get the <strong>most similar action</strong> and its index given the player input</li>",ge,D,Si,ce,V,ve,K,Pi="We need to define the <strong>behavior of our robot</strong>.",de,Q,ki="The idea is that our robot has different possible actions and the choice of the actions <strong>will depend on most similar actions</strong>.",we,X,Ii="We need first to define the <em>Finite State Machine</em>, a simple <strong>classical AI technique where each State defines a certain behavior</strong>.",ye,Z,ji="Then, we’ll make the utility function <strong>that will select the State hence the series of actions to perform</strong>.",be,tt,Te,et,Gi="In a state machine, <strong>each state represents a behavior</strong>, for instance, moving to a column, saying hello, etc. Based on the state the agent is <strong>it will perform a series of actions</strong>.",_e,it,Ui="In our case, we have 7 states:",xe,lt,Ai,Me,nt,Oi="The first thing we need to do is create an enum called State that contains each of the possible States:",$e,st,qi,Le,at,zi="Because we need to constantly check the state, <strong>we define the state machine into the Update() method using a switch system where each case is a state</strong>.",Ce,rt,Ri,He,ot,Bi="For each state case, we define the behavior of our agents, for instance in our state Hello, the robot <strong>must move towards the player, face him correctly, and then launch its Hello animation, then go back to an Idle State</strong>.",Se,ut,Ei,Pe,mt,Ji="We have now defined the behavior for each different State. The magic here will come from the fact <strong>that’s the language model that will define what State is the closest to the Player input</strong>. And in the utility function, we call this state.",ke,pt,Ie,ft,Wi="Our action list looks like this:",je,ht,Fi,Ge,gt,Ni="<li><p>The sentence is what will be embedded in the AI model.</p></li> <li><p>The verb is the State</p></li> <li><p>Noun (if any) is the object to interact with (Pillar, Cube, etc.)</p></li>",Ue,ct,Yi="This utility function will <strong>select the Verb and Noun associated with the sentence having the highest similarity score with the player input text.</strong>",Ae,vt,Di="But first, to <strong>get rid of a lot of strange input text</strong>, we need to have a similarity <strong>score threshold</strong>.",Oe,dt,Vi="For example, if I say “Look at all the rabbits”, <strong>none of our possible actions are relevant</strong>. Hence instead of choosing the action with the highest score, we’ll call the State Puzzled which will animate the robot with a perplexed animation.",qe,wt,Ki,ze,yt,Qi="If the score is higher, then <strong>we’ll get the verb corresponding to a State and the noun (goalObject) if any</strong>.",Re,bt,Xi="We set the state corresponding to the verb. That will activate the behavior corresponding to it.",Be,Tt,Zi,Ee,_t,tl="And that’s it, <strong>now we’re ready to interact with our robot!</strong>",Je,xt,We,Mt,el="In this step, you just need to click on the play button in the editor. And you <strong>can prompt some orders and see the results</strong>!",Fe,$t,il="That’s nice! But the best way to learn is to try things, break things and modify the demo.",Ne,Lt,Ye,Ct,ll="Adding a new action is quite easy. Let’s take an example:",De,Ht,nl="<li><p>Copy the YellowPillar game object and move it</p></li> <li><p>Change the name to GreenPillar</p></li> <li><p>Create a new material and set it to green</p></li> <li><p>Place the material on GreenPillar</p></li>",Ve,St,sl="Now that we’ve placed the new game object, we need to add this possibility into the sentences and click on Jammo_Player.",Ke,Pt,al="In the list of actions click on the plus button and fill in this new action item:",Qe,kt,rl,Xe,It,ol="<li>Add Go to the green column</li> <li>GoTo</li> <li>GreenColumn</li>",Ze,jt,ul="And that’s it! <strong>You can easily iterate and add more actions to your game</strong>.",ti,Gt,ml="Again, don’t forget to test the similarity threshold, <strong>to see if you need to increase it or decrease it</strong>.",ei,Ut,ii,Ot,li;return _=new d({props:{title:"Let’s build our smart robot NPC demo 🤖",local:"lets-build-our-smart-robot-npc-demo-",headingTag:"h1"}}),x=new d({props:{title:"Step 0: Get the project files",local:"step-0-get-the-project-files",headingTag:"h2"}}),$=new d({props:{title:"Step 1: Install Unity Sentis",local:"step-1-install-unity-sentis",headingTag:"h2"}}),k=new d({props:{title:"Step 2: Install Sharp Transformers 💪",local:"step-2-install-sharp-transformers-",headingTag:"h2"}}),O=new d({props:{title:"Step 3: Build the inference process 🧠",local:"step-3-build-the-inference-process-",headingTag:"h2"}}),V=new d({props:{title:"Step 4: Build the Robot Behavior 🤖",local:"step-4-build-the-robot-behavior-",headingTag:"h2"}}),tt=new d({props:{title:"The State Machine 🧠🤖",local:"the-state-machine-",headingTag:"h3"}}),pt=new d({props:{title:"Let’s define the Utility Function 📈",local:"lets-define-the-utility-function-",headingTag:"h3"}}),xt=new d({props:{title:"Step 5: Let’s interact with our Robot 🤖",local:"step-5-lets-interact-with-our-robot-",headingTag:"h2"}}),Lt=new d({props:{title:"(Optional) Improving the game: let’s add a new action",local:"optional-improving-the-game-lets-add-a-new-action",headingTag:"h2"}}),Ut=new yl({props:{source:"https://github.com/huggingface/making-games-with-ai-course/blob/main/units/en/unit1/make-demo.mdx"}}),{c(){w=a("meta"),qt=n(),At=a("p"),zt=n(),p(_.$$.fragment),Rt=n(),p(x.$$.fragment),Bt=n(),M=a("p"),M.innerHTML=si,Et=n(),p($.$$.fragment),Jt=n(),L=a("p"),L.innerHTML=ai,Wt=n(),C=a("ol"),C.innerHTML=ri,Ft=n(),H=a("img"),Nt=n(),S=a("p"),S.innerHTML=ui,Yt=n(),y=a("ol"),y.innerHTML=mi,Dt=n(),P=a("img"),Vt=n(),p(k.$$.fragment),Kt=n(),I=a("p"),I.innerHTML=fi,Qt=n(),j=a("p"),j.textContent=hi,Xt=n(),G=a("p"),G.textContent=gi,Zt=n(),U=a("p"),U.textContent=ci,te=n(),A=a("p"),A.innerHTML=vi,ee=n(),p(O.$$.fragment),ie=n(),q=a("p"),q.innerHTML=di,le=n(),z=a("ol"),z.innerHTML=wi,ne=n(),R=a("p"),R.innerHTML=yi,se=n(),B=a("p"),B.textContent=bi,ae=n(),E=a("ol"),E.innerHTML=Ti,re=n(),J=a("img"),oe=n(),W=a("p"),W.textContent=xi,ue=n(),F=a("ol"),F.innerHTML=Mi,me=n(),N=a("img"),pe=n(),b=a("ol"),b.innerHTML=Li,fe=n(),Y=a("img"),he=n(),T=a("ol"),T.innerHTML=Hi,ge=n(),D=a("img"),ce=n(),p(V.$$.fragment),ve=n(),K=a("p"),K.innerHTML=Pi,de=n(),Q=a("p"),Q.innerHTML=ki,we=n(),X=a("p"),X.innerHTML=Ii,ye=n(),Z=a("p"),Z.innerHTML=ji,be=n(),p(tt.$$.fragment),Te=n(),et=a("p"),et.innerHTML=Gi,_e=n(),it=a("p"),it.textContent=Ui,xe=n(),lt=a("img"),Me=n(),nt=a("p"),nt.textContent=Oi,$e=n(),st=a("img"),Le=n(),at=a("p"),at.innerHTML=zi,Ce=n(),rt=a("img"),He=n(),ot=a("p"),ot.innerHTML=Bi,Se=n(),ut=a("img"),Pe=n(),mt=a("p"),mt.innerHTML=Ji,ke=n(),p(pt.$$.fragment),Ie=n(),ft=a("p"),ft.textContent=Wi,je=n(),ht=a("img"),Ge=n(),gt=a("ul"),gt.innerHTML=Ni,Ue=n(),ct=a("p"),ct.innerHTML=Yi,Ae=n(),vt=a("p"),vt.innerHTML=Di,Oe=n(),dt=a("p"),dt.innerHTML=Vi,qe=n(),wt=a("img"),ze=n(),yt=a("p"),yt.innerHTML=Qi,Re=n(),bt=a("p"),bt.textContent=Xi,Be=n(),Tt=a("img"),Ee=n(),_t=a("p"),_t.innerHTML=tl,Je=n(),p(xt.$$.fragment),We=n(),Mt=a("p"),Mt.innerHTML=el,Fe=n(),$t=a("p"),$t.textContent=il,Ne=n(),p(Lt.$$.fragment),Ye=n(),Ct=a("p"),Ct.textContent=ll,De=n(),Ht=a("ul"),Ht.innerHTML=nl,Ve=n(),St=a("p"),St.textContent=sl,Ke=n(),Pt=a("p"),Pt.textContent=al,Qe=n(),kt=a("img"),Xe=n(),It=a("ul"),It.innerHTML=ol,Ze=n(),jt=a("p"),jt.innerHTML=ul,ti=n(),Gt=a("p"),Gt.innerHTML=ml,ei=n(),p(Ut.$$.fragment),ii=n(),Ot=a("p"),this.h()},l(t){const e=dl("svelte-u9bgzb",document.head);w=r(e,"META",{name:!0,content:!0}),e.forEach(i),qt=s(t),At=r(t,"P",{}),pl(At).forEach(i),zt=s(t),f(_.$$.fragment,t),Rt=s(t),f(x.$$.fragment,t),Bt=s(t),M=r(t,"P",{"data-svelte-h":!0}),o(M)!=="svelte-1yl9hlo"&&(M.innerHTML=si),Et=s(t),f($.$$.fragment,t),Jt=s(t),L=r(t,"P",{"data-svelte-h":!0}),o(L)!=="svelte-opv8w8"&&(L.innerHTML=ai),Wt=s(t),C=r(t,"OL",{"data-svelte-h":!0}),o(C)!=="svelte-1be145u"&&(C.innerHTML=ri),Ft=s(t),H=r(t,"IMG",{src:!0,alt:!0}),Nt=s(t),S=r(t,"P",{"data-svelte-h":!0}),o(S)!=="svelte-2j811b"&&(S.innerHTML=ui),Yt=s(t),y=r(t,"OL",{start:!0,"data-svelte-h":!0}),o(y)!=="svelte-5tt8x1"&&(y.innerHTML=mi),Dt=s(t),P=r(t,"IMG",{src:!0,alt:!0}),Vt=s(t),f(k.$$.fragment,t),Kt=s(t),I=r(t,"P",{"data-svelte-h":!0}),o(I)!=="svelte-1z124e9"&&(I.innerHTML=fi),Qt=s(t),j=r(t,"P",{"data-svelte-h":!0}),o(j)!=="svelte-xasv72"&&(j.textContent=hi),Xt=s(t),G=r(t,"P",{"data-svelte-h":!0}),o(G)!=="svelte-1qa8kbx"&&(G.textContent=gi),Zt=s(t),U=r(t,"P",{"data-svelte-h":!0}),o(U)!=="svelte-19zcx5u"&&(U.textContent=ci),te=s(t),A=r(t,"P",{"data-svelte-h":!0}),o(A)!=="svelte-1bqyha7"&&(A.innerHTML=vi),ee=s(t),f(O.$$.fragment,t),ie=s(t),q=r(t,"P",{"data-svelte-h":!0}),o(q)!=="svelte-gwh6bq"&&(q.innerHTML=di),le=s(t),z=r(t,"OL",{"data-svelte-h":!0}),o(z)!=="svelte-11c6hj8"&&(z.innerHTML=wi),ne=s(t),R=r(t,"P",{"data-svelte-h":!0}),o(R)!=="svelte-1bxothf"&&(R.innerHTML=yi),se=s(t),B=r(t,"P",{"data-svelte-h":!0}),o(B)!=="svelte-17c2lau"&&(B.textContent=bi),ae=s(t),E=r(t,"OL",{"data-svelte-h":!0}),o(E)!=="svelte-1mwm3hf"&&(E.innerHTML=Ti),re=s(t),J=r(t,"IMG",{src:!0,alt:!0}),oe=s(t),W=r(t,"P",{"data-svelte-h":!0}),o(W)!=="svelte-gchvph"&&(W.textContent=xi),ue=s(t),F=r(t,"OL",{"data-svelte-h":!0}),o(F)!=="svelte-1bbbmof"&&(F.innerHTML=Mi),me=s(t),N=r(t,"IMG",{src:!0,alt:!0}),pe=s(t),b=r(t,"OL",{start:!0,"data-svelte-h":!0}),o(b)!=="svelte-ehcevs"&&(b.innerHTML=Li),fe=s(t),Y=r(t,"IMG",{src:!0,alt:!0}),he=s(t),T=r(t,"OL",{start:!0,"data-svelte-h":!0}),o(T)!=="svelte-q0d6cq"&&(T.innerHTML=Hi),ge=s(t),D=r(t,"IMG",{src:!0,alt:!0}),ce=s(t),f(V.$$.fragment,t),ve=s(t),K=r(t,"P",{"data-svelte-h":!0}),o(K)!=="svelte-15whxm9"&&(K.innerHTML=Pi),de=s(t),Q=r(t,"P",{"data-svelte-h":!0}),o(Q)!=="svelte-1lrk8k1"&&(Q.innerHTML=ki),we=s(t),X=r(t,"P",{"data-svelte-h":!0}),o(X)!=="svelte-1kn8gok"&&(X.innerHTML=Ii),ye=s(t),Z=r(t,"P",{"data-svelte-h":!0}),o(Z)!=="svelte-4iyzzc"&&(Z.innerHTML=ji),be=s(t),f(tt.$$.fragment,t),Te=s(t),et=r(t,"P",{"data-svelte-h":!0}),o(et)!=="svelte-5rbi8n"&&(et.innerHTML=Gi),_e=s(t),it=r(t,"P",{"data-svelte-h":!0}),o(it)!=="svelte-1fffpiy"&&(it.textContent=Ui),xe=s(t),lt=r(t,"IMG",{src:!0,alt:!0}),Me=s(t),nt=r(t,"P",{"data-svelte-h":!0}),o(nt)!=="svelte-2wbpmd"&&(nt.textContent=Oi),$e=s(t),st=r(t,"IMG",{src:!0,alt:!0}),Le=s(t),at=r(t,"P",{"data-svelte-h":!0}),o(at)!=="svelte-120cind"&&(at.innerHTML=zi),Ce=s(t),rt=r(t,"IMG",{src:!0,alt:!0}),He=s(t),ot=r(t,"P",{"data-svelte-h":!0}),o(ot)!=="svelte-1shiqaw"&&(ot.innerHTML=Bi),Se=s(t),ut=r(t,"IMG",{src:!0,alt:!0}),Pe=s(t),mt=r(t,"P",{"data-svelte-h":!0}),o(mt)!=="svelte-1jrao99"&&(mt.innerHTML=Ji),ke=s(t),f(pt.$$.fragment,t),Ie=s(t),ft=r(t,"P",{"data-svelte-h":!0}),o(ft)!=="svelte-bsbp3"&&(ft.textContent=Wi),je=s(t),ht=r(t,"IMG",{src:!0,alt:!0}),Ge=s(t),gt=r(t,"UL",{"data-svelte-h":!0}),o(gt)!=="svelte-6bwl87"&&(gt.innerHTML=Ni),Ue=s(t),ct=r(t,"P",{"data-svelte-h":!0}),o(ct)!=="svelte-16jnw1u"&&(ct.innerHTML=Yi),Ae=s(t),vt=r(t,"P",{"data-svelte-h":!0}),o(vt)!=="svelte-gpawhm"&&(vt.innerHTML=Di),Oe=s(t),dt=r(t,"P",{"data-svelte-h":!0}),o(dt)!=="svelte-1hi969r"&&(dt.innerHTML=Vi),qe=s(t),wt=r(t,"IMG",{src:!0,alt:!0}),ze=s(t),yt=r(t,"P",{"data-svelte-h":!0}),o(yt)!=="svelte-idtp6m"&&(yt.innerHTML=Qi),Re=s(t),bt=r(t,"P",{"data-svelte-h":!0}),o(bt)!=="svelte-1yk26hk"&&(bt.textContent=Xi),Be=s(t),Tt=r(t,"IMG",{src:!0,alt:!0}),Ee=s(t),_t=r(t,"P",{"data-svelte-h":!0}),o(_t)!=="svelte-hcv1yn"&&(_t.innerHTML=tl),Je=s(t),f(xt.$$.fragment,t),We=s(t),Mt=r(t,"P",{"data-svelte-h":!0}),o(Mt)!=="svelte-1kbnmju"&&(Mt.innerHTML=el),Fe=s(t),$t=r(t,"P",{"data-svelte-h":!0}),o($t)!=="svelte-1t6d83x"&&($t.textContent=il),Ne=s(t),f(Lt.$$.fragment,t),Ye=s(t),Ct=r(t,"P",{"data-svelte-h":!0}),o(Ct)!=="svelte-1rlfwth"&&(Ct.textContent=ll),De=s(t),Ht=r(t,"UL",{"data-svelte-h":!0}),o(Ht)!=="svelte-1dl51k5"&&(Ht.innerHTML=nl),Ve=s(t),St=r(t,"P",{"data-svelte-h":!0}),o(St)!=="svelte-22rtac"&&(St.textContent=sl),Ke=s(t),Pt=r(t,"P",{"data-svelte-h":!0}),o(Pt)!=="svelte-18hx0iy"&&(Pt.textContent=al),Qe=s(t),kt=r(t,"IMG",{src:!0,alt:!0}),Xe=s(t),It=r(t,"UL",{"data-svelte-h":!0}),o(It)!=="svelte-q2rtbz"&&(It.innerHTML=ol),Ze=s(t),jt=r(t,"P",{"data-svelte-h":!0}),o(jt)!=="svelte-wsbu0l"&&(jt.innerHTML=ul),ti=s(t),Gt=r(t,"P",{"data-svelte-h":!0}),o(Gt)!=="svelte-11a9ito"&&(Gt.innerHTML=ml),ei=s(t),f(Ut.$$.fragment,t),ii=s(t),Ot=r(t,"P",{}),pl(Ot).forEach(i),this.h()},h(){u(w,"name","hf:doc:metadata"),u(w,"content",Tl),m(H.src,oi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis1.jpg")||u(H,"src",oi),u(H,"alt","Sentis"),u(y,"start","3"),m(P.src,pi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis2.png")||u(P,"src",pi),u(P,"alt","Sentis"),m(J.src,_i="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis-similarity1.jpg")||u(J,"src",_i),u(J,"alt","Sentis Similarity"),m(N.src,$i="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis-similarity2.jpg")||u(N,"src",$i),u(N,"alt","Sentis Similarity"),u(b,"start","2"),m(Y.src,Ci="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis-similarity3.jpg")||u(Y,"src",Ci),u(Y,"alt","Sentis Similarity"),u(T,"start","3"),m(D.src,Si="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis-similarity4.jpg")||u(D,"src",Si),u(D,"alt","Sentis Similarity"),m(lt.src,Ai="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/fsm.jpg")||u(lt,"src",Ai),u(lt,"alt","Jammo State Machine"),m(st.src,qi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/fsm2.jpg")||u(st,"src",qi),u(st,"alt","Jammo State Machine"),m(rt.src,Ri="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/fsm3.jpg")||u(rt,"src",Ri),u(rt,"alt","Jammo State Machine"),m(ut.src,Ei="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/fsm4.jpg")||u(ut,"src",Ei),u(ut,"alt","Jammo State Machine"),m(ht.src,Fi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/utility1.jpg")||u(ht,"src",Fi),u(ht,"alt","Utility"),m(wt.src,Ki="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/rabbits.gif")||u(wt,"src",Ki),u(wt,"alt","Jammo rabbits"),m(Tt.src,Zi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/utility2.jpg")||u(Tt,"src",Zi),u(Tt,"alt","Utility"),m(kt.src,rl="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/optional-jammo1.jpg")||u(kt,"src",rl),u(kt,"alt","Utility")},m(t,e){wl(document.head,w),l(t,qt,e),l(t,At,e),l(t,zt,e),h(_,t,e),l(t,Rt,e),h(x,t,e),l(t,Bt,e),l(t,M,e),l(t,Et,e),h($,t,e),l(t,Jt,e),l(t,L,e),l(t,Wt,e),l(t,C,e),l(t,Ft,e),l(t,H,e),l(t,Nt,e),l(t,S,e),l(t,Yt,e),l(t,y,e),l(t,Dt,e),l(t,P,e),l(t,Vt,e),h(k,t,e),l(t,Kt,e),l(t,I,e),l(t,Qt,e),l(t,j,e),l(t,Xt,e),l(t,G,e),l(t,Zt,e),l(t,U,e),l(t,te,e),l(t,A,e),l(t,ee,e),h(O,t,e),l(t,ie,e),l(t,q,e),l(t,le,e),l(t,z,e),l(t,ne,e),l(t,R,e),l(t,se,e),l(t,B,e),l(t,ae,e),l(t,E,e),l(t,re,e),l(t,J,e),l(t,oe,e),l(t,W,e),l(t,ue,e),l(t,F,e),l(t,me,e),l(t,N,e),l(t,pe,e),l(t,b,e),l(t,fe,e),l(t,Y,e),l(t,he,e),l(t,T,e),l(t,ge,e),l(t,D,e),l(t,ce,e),h(V,t,e),l(t,ve,e),l(t,K,e),l(t,de,e),l(t,Q,e),l(t,we,e),l(t,X,e),l(t,ye,e),l(t,Z,e),l(t,be,e),h(tt,t,e),l(t,Te,e),l(t,et,e),l(t,_e,e),l(t,it,e),l(t,xe,e),l(t,lt,e),l(t,Me,e),l(t,nt,e),l(t,$e,e),l(t,st,e),l(t,Le,e),l(t,at,e),l(t,Ce,e),l(t,rt,e),l(t,He,e),l(t,ot,e),l(t,Se,e),l(t,ut,e),l(t,Pe,e),l(t,mt,e),l(t,ke,e),h(pt,t,e),l(t,Ie,e),l(t,ft,e),l(t,je,e),l(t,ht,e),l(t,Ge,e),l(t,gt,e),l(t,Ue,e),l(t,ct,e),l(t,Ae,e),l(t,vt,e),l(t,Oe,e),l(t,dt,e),l(t,qe,e),l(t,wt,e),l(t,ze,e),l(t,yt,e),l(t,Re,e),l(t,bt,e),l(t,Be,e),l(t,Tt,e),l(t,Ee,e),l(t,_t,e),l(t,Je,e),h(xt,t,e),l(t,We,e),l(t,Mt,e),l(t,Fe,e),l(t,$t,e),l(t,Ne,e),h(Lt,t,e),l(t,Ye,e),l(t,Ct,e),l(t,De,e),l(t,Ht,e),l(t,Ve,e),l(t,St,e),l(t,Ke,e),l(t,Pt,e),l(t,Qe,e),l(t,kt,e),l(t,Xe,e),l(t,It,e),l(t,Ze,e),l(t,jt,e),l(t,ti,e),l(t,Gt,e),l(t,ei,e),h(Ut,t,e),l(t,ii,e),l(t,Ot,e),li=!0},p:hl,i(t){li||(g(_.$$.fragment,t),g(x.$$.fragment,t),g($.$$.fragment,t),g(k.$$.fragment,t),g(O.$$.fragment,t),g(V.$$.fragment,t),g(tt.$$.fragment,t),g(pt.$$.fragment,t),g(xt.$$.fragment,t),g(Lt.$$.fragment,t),g(Ut.$$.fragment,t),li=!0)},o(t){c(_.$$.fragment,t),c(x.$$.fragment,t),c($.$$.fragment,t),c(k.$$.fragment,t),c(O.$$.fragment,t),c(V.$$.fragment,t),c(tt.$$.fragment,t),c(pt.$$.fragment,t),c(xt.$$.fragment,t),c(Lt.$$.fragment,t),c(Ut.$$.fragment,t),li=!1},d(t){t&&(i(qt),i(At),i(zt),i(Rt),i(Bt),i(M),i(Et),i(Jt),i(L),i(Wt),i(C),i(Ft),i(H),i(Nt),i(S),i(Yt),i(y),i(Dt),i(P),i(Vt),i(Kt),i(I),i(Qt),i(j),i(Xt),i(G),i(Zt),i(U),i(te),i(A),i(ee),i(ie),i(q),i(le),i(z),i(ne),i(R),i(se),i(B),i(ae),i(E),i(re),i(J),i(oe),i(W),i(ue),i(F),i(me),i(N),i(pe),i(b),i(fe),i(Y),i(he),i(T),i(ge),i(D),i(ce),i(ve),i(K),i(de),i(Q),i(we),i(X),i(ye),i(Z),i(be),i(Te),i(et),i(_e),i(it),i(xe),i(lt),i(Me),i(nt),i($e),i(st),i(Le),i(at),i(Ce),i(rt),i(He),i(ot),i(Se),i(ut),i(Pe),i(mt),i(ke),i(Ie),i(ft),i(je),i(ht),i(Ge),i(gt),i(Ue),i(ct),i(Ae),i(vt),i(Oe),i(dt),i(qe),i(wt),i(ze),i(yt),i(Re),i(bt),i(Be),i(Tt),i(Ee),i(_t),i(Je),i(We),i(Mt),i(Fe),i($t),i(Ne),i(Ye),i(Ct),i(De),i(Ht),i(Ve),i(St),i(Ke),i(Pt),i(Qe),i(kt),i(Xe),i(It),i(Ze),i(jt),i(ti),i(Gt),i(ei),i(ii),i(Ot)),i(w),v(_,t),v(x,t),v($,t),v(k,t),v(O,t),v(V,t),v(tt,t),v(pt,t),v(xt,t),v(Lt,t),v(Ut,t)}}}const Tl='{"title":"Let’s build our smart robot NPC demo 🤖","local":"lets-build-our-smart-robot-npc-demo-","sections":[{"title":"Step 0: Get the project files","local":"step-0-get-the-project-files","sections":[],"depth":2},{"title":"Step 1: Install Unity Sentis","local":"step-1-install-unity-sentis","sections":[],"depth":2},{"title":"Step 2: Install Sharp Transformers 💪","local":"step-2-install-sharp-transformers-","sections":[],"depth":2},{"title":"Step 3: Build the inference process 🧠","local":"step-3-build-the-inference-process-","sections":[],"depth":2},{"title":"Step 4: Build the Robot Behavior 🤖","local":"step-4-build-the-robot-behavior-","sections":[{"title":"The State Machine 🧠🤖","local":"the-state-machine-","sections":[],"depth":3},{"title":"Let’s define the Utility Function 📈","local":"lets-define-the-utility-function-","sections":[],"depth":3}],"depth":2},{"title":"Step 5: Let’s interact with our Robot 🤖","local":"step-5-lets-interact-with-our-robot-","sections":[],"depth":2},{"title":"(Optional) Improving the game: let’s add a new action","local":"optional-improving-the-game-lets-add-a-new-action","sections":[],"depth":2}],"depth":1}';function _l(ni){return gl(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ll extends cl{constructor(w){super(),vl(this,w,_l,bl,fl,{})}}export{Ll as component};
